#!/usr/bin/python

import hashlib
import os

fileTypes = ['map', 'enemy', 'tower', 'projectile']

out = open('Code/Hashes.h', 'wt')
out.write("//\n")
out.write("// AUTO GENERATED BY BUILD PROCESS, DO NOT MODIFY!\n")
out.write("//\n")
out.write("static NSString* sMd5FileHashes[] = \n")
out.write("{\n")

for dirpath, dirnames, filenames in os.walk("Resources"):
	for filename in filenames:
		if ('.' not in filename):
			continue

		if (filename.split('.')[1] in fileTypes):
			m = hashlib.md5()
			# The file contents are lower-cased for additional obscurity.
			# - See Code/CryptoUtilities.m for the other end of this.
			m.update(open(os.path.join(dirpath, filename), 'rb').read())			
			# Secret-sauce  XOR the hash with an arbitrary prime number to 
			# obfuscate the value hidden in the code.  This is also done when 
			# generating the hashes in gen_hashes.py.
			digest = "".join(chr(ord(x) ^ 42) for x in m.digest())
			out.write('\t@"%s", // %s\n' % (digest.encode("hex").upper(), filename))

out.write("\tnil\n")
out.write("};\n")

